// hookmanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "hookman.h"
#include "hookmanDlg.h"
#include "../hookdll/hook.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_TXT 36


/////////////////////////////////////////////////////////////////////////////
// CHookmanDlg dialog

CHookmanDlg::CHookmanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHookmanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHookmanDlg)
	m_bTransition = FALSE;
	m_bPrevious = FALSE;
	m_bAlt = FALSE;
	m_bExtended = FALSE;
	m_csLogBox = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHookmanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHookmanDlg)
	DDX_Control(pDX, IDC_LOGBOX, m_LogBoxCtrl);
	DDX_Control(pDX, IDC_TESTBOX, m_TestBoxCtrl);
	DDX_Check(pDX, IDC_TRANSITION, m_bTransition);
	DDX_Check(pDX, IDC_PREVIOUS, m_bPrevious);
	DDX_Check(pDX, IDC_ALT, m_bAlt);
	DDX_Check(pDX, IDC_EXTENDED, m_bExtended);
	DDX_Text(pDX, IDC_LOGBOX, m_csLogBox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHookmanDlg, CDialog)
	//{{AFX_MSG_MAP(CHookmanDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SET, OnSet)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_WM_COPYDATA()
	ON_WM_DESTROY()
	ON_EN_CHANGE(IDC_LOGBOX, OnChangeLogbox)
	ON_BN_CLICKED(IDC_SET, OnSet)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




/////////////////////////////////////////////////////////////////////////////
// CHookmanDlg message handlers




BOOL CHookmanDlg::OnInitDialog()
  {
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// initialize member variables
  m_bTransition = false;
  m_bPrevious   = false;
  m_bAlt        = false;
  m_bExtended   = false;

  m_LogBoxCtrl.SetLimitText(MAX_TXT+1);                                         // limit number of chars in CEdit CTRL to MAX_TXT+1
  UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
  }




// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CHookmanDlg::OnPaint() 
  {
	if (IsIconic())
	  {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	  }
	else
	  {
		CDialog::OnPaint();
	  }
  }



// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHookmanDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



//
// set hook when the "set"-button is pressed
//
void CHookmanDlg::OnSet() 
  {
  SetHook(this->m_hWnd);
  m_TestBoxCtrl.SetFocus();                                                     // focus the test edit field to allow typeing text
  }




//
// remove hook when the "remove"-button is pressed
//
void CHookmanDlg::OnRemove() 
  {
  RemoveHook();
  }



//
// the copydata-message-handler is triggered by the WM_COPYDATA message
// the struct COPYDATASTRUCT contains a pointer to HEVENT which stores
// information on the hooked keycodes
//
BOOL CHookmanDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
  {
  if( pCopyDataStruct->cbData!=sizeof(HEVENT) || ((HEVENT*)pCopyDataStruct->lpData)->dwHookType != WH_KEYBOARD)
	  return CDialog::OnCopyData(pWnd, pCopyDataStruct);

  HEVENT Event;
  memcpy(&Event, (HEVENT*)pCopyDataStruct->lpData, sizeof(HEVENT));             // transfer data to internal variable

  // compute the additional keycode info in lParam
  m_bTransition = (((DWORD)KF_UP<<16)&Event.lParam)!=0;
  m_bPrevious   = (0x40000000&Event.lParam)!=0;
  m_bAlt        = (((DWORD)KF_ALTDOWN<<16)&Event.lParam)!=0;
  m_bExtended   = (((DWORD)KF_EXTENDED<<16)&Event.lParam)!=0;
  ::PostMessage(m_LogBoxCtrl.m_hWnd, m_bTransition?WM_KEYDOWN:WM_KEYUP, Event.wParam, Event.lParam);

  // display the numeric values in lParam, wParam and repeat count
  char szParam[10];
  sprintf(szParam, "%u", (unsigned long)Event.lParam);
  SetDlgItemText(IDC_LPARAM, szParam);
  sprintf(szParam, "%u", (unsigned long)Event.wParam);
  SetDlgItemText(IDC_WPARAM, szParam);

  sprintf(szParam, "%u", (0xFF0000&Event.lParam)>>16);
  SetDlgItemText(IDC_SCANCODE, szParam);

  sprintf(szParam, "%u", 0xFFFF&Event.lParam);
  SetDlgItemText(IDC_REPEATCOUNT, szParam);

  UpdateData(false);
  return(FALSE);
  }





//
// implement kind of scrolling text, if the string in CEdit longer than MAX_TXT
//
void CHookmanDlg::OnChangeLogbox() 
  {
  UpdateData(true);
  if(strlen(m_csLogBox)>MAX_TXT)
    {
    m_csLogBox = m_csLogBox.Right(strlen(m_csLogBox)-1);
    UpdateData(false);
    m_LogBoxCtrl.SetSel(MAX_TXT, MAX_TXT);
    UpdateData(false);
    }
  }




//
// overrride standard destroy handler to safely unhook when we quit
//
void CHookmanDlg::OnDestroy() 
  {
  RemoveHook();
	CDialog::OnDestroy();
  }
